/******************************************************************************/
/*                                                                            */
/* Trigger: IMPORTA_CLIENTE_ASSINANTE                                         */
/* Tabela : USR_ASSINANTE                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 08/09/2008 - Andr Rodrigo                                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER IMPORTA_CLIENTE_ASSINANTE
AFTER INSERT OR UPDATE ON USR_ASSINANTE
FOR EACH ROW

DECLARE
  V_IDTPIJUR   VARCHAR2(1);
  V_CDCLIENTE  VARCHAR2(21);
  V_NRINSJUR   VARCHAR2(20);
  V_EMAIL1     VARCHAR2(50);
  V_EMAIL2     VARCHAR2(50);
  V_RAZSOC     VARCHAR2(50);
BEGIN
   IF NOT :NEW.CNPJ_ASSINANTE IS NULL THEN
      V_IDTPIJUR  := 'J';
      V_NRINSJUR  := :NEW.CNPJ_ASSINANTE;
   ELSE
      V_IDTPIJUR  := 'F';
      V_NRINSJUR  := :NEW.CPF_ASSINANTE;
   END IF;

   V_CDCLIENTE := V_IDTPIJUR || V_NRINSJUR;

   IF :NEW.RAZAO_SOCIAL_ASSINANTE IS NULL THEN
      V_RAZSOC := :NEW.NOME_ASSINANTE;
   ELSE
      V_RAZSOC := :NEW.RAZAO_SOCIAL_ASSINANTE;
   END IF;

   IF INSERTING THEN

      INSERT INTO CLIENTE
         (CDCLIENTE,  IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE,
          DTCADACLIE, DTNASCCLIE,   IDSEXOCLIE)
      VALUES
         (V_CDCLIENTE, V_IDTPIJUR, V_NRINSJUR, V_RAZSOC, :NEW.NOME_ASSINANTE,
          SYSDATE, :NEW.DATA_NASC_ASSINANTE, :NEW.SEXO_ASSINANTE);

      V_EMAIL1 := '';
      V_EMAIL2 := '';
      IF NOT :NEW.EMAIL_PESSOAL_ASSINANTE IS NULL THEN
         V_EMAIL1 := SUBSTR(:NEW.EMAIL_PESSOAL_ASSINANTE, 1, 50);
      END IF;
      IF NOT :NEW.EMAIL_COM_ASSINANTE IS NULL THEN
         V_EMAIL2 := SUBSTR(:NEW.EMAIL_COM_ASSINANTE, 1, 50);
      END IF;

      INSERT INTO ENDECLIE
         (CDCLIENTE,    IDTPENDECLIE, CDPAIS,     SGESTADO,  CDMUNICIPIO,
          DSENDECLIE,   DSCOMPENDCLI, NMBAIRCLIE, NRCEPCLIE,
          NRTELRESICLI, NRCELULARCLI, NRTELECLIE, NRTELECLIE1,
          DSEMAILCLIE,  DSEMAILCLIE2)
      VALUES
         (V_CDCLIENTE, 'P', :NEW.PAIS_ASSINANTE, :NEW.ESTADO_ASSINANTE, :NEW.CIDADE_ASSINANTE,
          :NEW.ENDERECO_ASSINANTE, :NEW.COMPLEMENTO_ENDER_ASSINANTE, :NEW.BAIRRO_ASSINANTE, :NEW.CEP_ASSINANTE,
          :NEW.TEL_RES_ASSINANTE, :NEW.TEL_CEL_ASSINANTE, :NEW.TEL_COM1_ASSINANTE, :NEW.TEL_COM2_ASSINANTE,
          V_EMAIL1, V_EMAIL2);
   END IF;

   IF UPDATING THEN
      UPDATE CLIENTE
      SET NMRAZSOCCLIE = V_RAZSOC,
          NMFANTCLIE = :NEW.NOME_ASSINANTE,
          DTNASCCLIE = :NEW.DATA_NASC_ASSINANTE,
          IDSEXOCLIE = :NEW.SEXO_ASSINANTE
      WHERE CDCLIENTE = V_CDCLIENTE;

      IF NOT :NEW.EMAIL_PESSOAL_ASSINANTE IS NULL THEN
         V_EMAIL1 := SUBSTR(:NEW.EMAIL_PESSOAL_ASSINANTE, 1, 50);
      END IF;
      IF NOT :NEW.EMAIL_COM_ASSINANTE IS NULL THEN
         V_EMAIL2 := SUBSTR(:NEW.EMAIL_COM_ASSINANTE, 1, 50);
      END IF;

      UPDATE ENDECLIE
      SET CDPAIS        = :NEW.PAIS_ASSINANTE,
          SGESTADO      = :NEW.ESTADO_ASSINANTE,
          CDMUNICIPIO   = :NEW.CIDADE_ASSINANTE,
          DSENDECLIE    = :NEW.ENDERECO_ASSINANTE,
          DSCOMPENDCLI  = :NEW.COMPLEMENTO_ENDER_ASSINANTE,
          NMBAIRCLIE    = :NEW.BAIRRO_ASSINANTE,
          NRCEPCLIE     = :NEW.CEP_ASSINANTE,
          NRTELRESICLI  = :NEW.TEL_RES_ASSINANTE,
          NRCELULARCLI  = :NEW.TEL_CEL_ASSINANTE,
          NRTELECLIE    = :NEW.TEL_COM1_ASSINANTE,
          NRTELECLIE1   = :NEW.TEL_COM2_ASSINANTE,
          DSEMAILCLIE   = V_EMAIL1,
          DSEMAILCLIE2  = V_EMAIL2
      WHERE CDCLIENTE = V_CDCLIENTE
        AND IDTPENDECLIE = 'P';
   END IF;
END;
/
